#include "libgccvb.h"
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddata.h"  // Actual sounds
#include "pacguymap.h"
#include "pacguychar.h"
#include "dotmap.h"
#include "dotchar.h"
#include "brix.h"
#include "wall1char.h"
#include "titlescreenmap.h"
#include "titlescreenchar.h"
#include "level1intromap.h"
#include "level1introchar.h"
#include "level1mapclosed.h"
#include "level1mapopen.h"
#include "enemiesmap.h"
#include "enemieschar.h"
#include "level2intromap.h"
#include "level2introchar.h"
#include "level2map.h"
#include "level2mapopen.h"




int pacguydir, pacguyx=24, pacguyy=281, pacguyfacingdir, dir, level=0;
int dot1x, dot1y, dot2x, dot2y, dot3x, dot3y, dot4x, dot4y, movingtimer;
int dotx, dotyadd, dotxadd, dotxsubtract, dotysubtract, dottimer, clearmaze=0;
int dot2x, dot2yadd, dot2xadd, dot2xsubtract, dot2ysubtract;
int enemyx, enemyy, enemymovetimer, enemydir, wall;
int enemycollxplus, enemycollxminus, enemycollyplus, enemycollyminus;
int ud=1, lr=1, snd=0, sndtimer=0;



HWORD getBGMapChar(bgmap, x, y)
    	{ 
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7FF);  
    	} 



void level_change()
{	
	if (level==0) copymem((void*)CharSeg1, (void*)LEVEL1INTROCHAR, 256*16);
	if (level==1) copymem((void*)CharSeg1, (void*)LEVEL2INTROCHAR, 256*16);
	if (level==1) copymem((void*)BGMap(1), (void*)LEVEL2INTROMAP, 256*16);
	if (level==0) copymem((void*)BGMap(1), (void*)LEVEL1INTROMAP, 256*16);
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	
	StopAllSounds;
	
	while(!(vbReadPad()&K_A)){}
	while(vbReadPad()&K_A){}	


	if (level==1) enemyx=340, enemyy=100, enemymovetimer=0;
	pacguyx=24, pacguyy=24;
	if (level==0) enemyx=400, enemyy=200, dot1x=160, dot1y=165, dot2x=40, dot2y=180;
	if (level==1) dot1x=340, dot1y=24, dot2x=340, dot2y=180;	
	
	if (level==0) copymem((void*)BGMap(1), (void*)LEVEL1MAPCLOSED, 256*16);	
	if (level==1) copymem((void*)BGMap(1), (void*)LEVEL2MAP, 256*16);	
	copymem((void*)CharSeg1, (void*)WALL1CHAR, 256*16);

	clearmaze=0;

	copymem((void*)CharSeg0, (void*)DOTCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)DOTMAP, 256*16);

	copymem((void*)CharSeg2, (void*)PACGUYCHAR, 256*16);
	copymem((void*)BGMap(2), (void*)PACGUYMAP, 256*16);	

	copymem((void*)CharSeg3, (void*)ENEMIESCHAR, 256*16);
	copymem((void*)BGMap(3), (void*)ENEMIESMAP, 256*16);	

	main_2();

}

int main()
{
	InitSound();
	main_3();
}

int main_3()
{
	vbDisplayOn();
	vbDisplayShow();	

	while(!(vbReadPad()&K_A))
	{
	DoSounds();

	PlaySound(tstreble);
	PlaySound(tsbass);

	
	copymem((void*)CharSeg1, (void*)TITLESCREENCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)TITLESCREENMAP, 256*16);
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);

	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	

	
	}
	level_change();
	}
	
	
int main_2 ()
	{

	StopAllSounds();
	while(!(vbReadPad()&K_STA))
	{

	DoSounds();

	if (level<2) {

	PlaySound(level1musictreble);
	PlaySound(level1musicbass);
	}		

	
	vbSetWorld(28, WRLD_ON|2, pacguyx, 0, pacguyy, pacguyfacingdir, 0, 0, 15, 40);	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);	
	vbSetWorld(30, WRLD_ON, dot1x, 0, dot1y, dotx, 0, 0, 7, 8);	
	vbSetWorld(29, WRLD_ON, dot2x, 0, dot2y, dotx, 0, 0, 7, 8);	
	vbSetWorld(27, WRLD_ON|3, enemyx, 0, enemyy, 0, 0, 0, 16, 16);	
	
	// collision detection on walls

	if((!(vbReadPad()&K_LR)) && (!(vbReadPad()&K_LL))) lr=1, movingtimer=0;
	if((!(vbReadPad()&K_LU)) && (!(vbReadPad()&K_LD))) ud=1, movingtimer=0;

	if((vbReadPad()&K_LL) && (ud==1) && (vbReadPad()&K_LU)) lr=0, movingtimer=0;
	if((vbReadPad()&K_LL) && (lr==1) && (vbReadPad()&K_LU)) ud=0, movingtimer=0;	
	if((vbReadPad()&K_LL) && (ud==1) && (vbReadPad()&K_LD)) lr=0, movingtimer=0;	
	if((vbReadPad()&K_LL) && (lr==1) && (vbReadPad()&K_LD)) ud=0, movingtimer=0;		
	if((vbReadPad()&K_LR) && (ud==1) && (vbReadPad()&K_LU)) lr=0, movingtimer=0;	
	if((vbReadPad()&K_LR) && (lr==1) && (vbReadPad()&K_LU)) ud=0, movingtimer=0;	
 	if((vbReadPad()&K_LR) && (ud==1) && (vbReadPad()&K_LD)) lr=0, movingtimer=0;		
	if((vbReadPad()&K_LR) && (lr==1) && (vbReadPad()&K_LD)) ud=0, movingtimer=0;

	
	

	if((vbReadPad()&K_LL) && (lr==1)) movingtimer++;	
	if((vbReadPad()&K_LL) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) pacguyx++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LL) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) pacguyx++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LL) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+1)==512)) pacguyx++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LL) && (movingtimer>0)) movingtimer=0, pacguyx--, dotxadd=-10, pacguyfacingdir=0;
	if((vbReadPad()&K_LL) && (pacguyfacingdir>0)) enemymovetimer=0;
	
	if((vbReadPad()&K_LR) && (lr==1)) movingtimer++;
	if((vbReadPad()&K_LR) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) pacguyx--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LR) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+1)==512)) pacguyx--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LR) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) pacguyx--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LR) && (movingtimer>0)) movingtimer=0, pacguyx++, dotxadd=0, pacguyfacingdir=32;
	if((vbReadPad()&K_LR) && (pacguyfacingdir<36) && (pacguyfacingdir>36)) enemymovetimer=0;
	
	if((vbReadPad()&K_LU) && (ud==1))  movingtimer++;
	if((vbReadPad()&K_LU) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+0)==512)) pacguyy++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LU) && (getBGMapChar(1, (pacguyx/8)+1, (pacguyy/8)+0)==512)) pacguyy++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LU) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+0)==512)) pacguyy++, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LU) && (movingtimer>0)) movingtimer=0, pacguyy--, dotyadd=-10, pacguyfacingdir=16;
	if((vbReadPad()&K_LR) && (pacguyfacingdir<16) && (pacguyfacingdir>16)) enemymovetimer=0;	
	
	if((vbReadPad()&K_LD) && (ud==1))  movingtimer++;
	if((vbReadPad()&K_LD) && (getBGMapChar(1, (pacguyx/8)+0, (pacguyy/8)+2)==512)) pacguyy--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (getBGMapChar(1, (pacguyx/8)+1, (pacguyy/8)+2)==512)) pacguyy--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (getBGMapChar(1, (pacguyx/8)+2, (pacguyy/8)+2)==512)) pacguyy--, lr=0, ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (movingtimer>0)) movingtimer=0, pacguyy++, dotyadd=-10, pacguyfacingdir=48;	
	if((vbReadPad()&K_LR) && (pacguyfacingdir>48)) enemymovetimer=0;
	
	

	dottimer++;
	if (dottimer>14) dottimer=0, dotx=dotx+8;
	if (dotx>24) dotx=0;

	
	// collision detection on dots
	
	dotxadd=dot1x-16, dotxsubtract=dot1x+8, dotyadd=dot1y-16, dotysubtract=dot1y+8;
	dot2xadd=dot2x-16, dot2xsubtract=dot2x+8, dot2yadd=dot2y-16, dot2ysubtract=dot2y+8;	
	
	if ((pacguyx>dotxadd) && (pacguyx<dotxsubtract) && (snd==0) && (pacguyy>dotyadd) && (pacguyy<dotysubtract)) dot1x=400;
	if ((pacguyx>dot2xadd) && (pacguyx<dot2xsubtract) && (snd==0) && (pacguyy>dot2yadd) && (pacguyy<dot2ysubtract)) dot2x=400; 

	if ((dot1x==400) && (clearmaze==0) && (dot2x==400)) clearmaze=1;
	
	

	
	
	if (pacguyy>210) level_change();
	
	
	if ((level==2) && (enemymovetimer==0) && (vbReadPad()&K_LL)) enemymovetimer++, enemydir=1;
	if ((level==2) && (enemymovetimer==0) && (vbReadPad()&K_LR)) enemymovetimer++, enemydir=2;
	if ((level==2) && (enemymovetimer==0) && (vbReadPad()&K_LU)) enemymovetimer++, enemydir=3;
	if ((level==2) && (enemymovetimer==0) && (vbReadPad()&K_LD)) enemymovetimer++, enemydir=4;
	
	if (enemymovetimer>0) enemymovetimer++;
	
	if (getBGMapChar(1, (enemyx/8)+0, (enemyy/8)+0)==512) enemyx++, enemyy++, enemydir=enemydir+2, wall++;
	if (getBGMapChar(1, (enemyx/8)+2, (enemyy/8)+0)==512) enemyx--, enemyy++, enemydir=enemydir+2, wall++;	
	if (getBGMapChar(1, (enemyx/8)+0, (enemyy/8)+2)==512) enemyx++, enemyy--, enemydir=enemydir+2, wall++;
	if (getBGMapChar(1, (enemyx/8)+2, (enemyy/8)+2)==512) enemyx--, enemyy--, enemydir=enemydir+2, wall++;	




	if (wall>1) wall=0;

	if ((pacguyx<enemyx) && (wall==0)) enemydir=2;	
	if ((pacguyx>enemyx) && (wall==0)) enemydir=1;
	if ((pacguyy>enemyy) && (wall==0)) enemydir=4;	
	if ((pacguyy<enemyy) && (wall==0)) enemydir=3;		
	
	
	enemycollxplus=enemyx+16, enemycollxminus=enemyx-16, enemycollyplus=enemyy+16, enemycollyminus=enemyy-16;
	if ((pacguyx>enemycollxminus) && (pacguyx<enemycollxplus) && (pacguyy>enemycollyminus) && (pacguyy<enemycollyplus)) level_change();
	
	
	
	if (enemydir>4) enemydir=1;
	
	if ((enemymovetimer>2) && (enemydir==2)) enemymovetimer=1, enemyx--;
	if ((enemymovetimer>2) && (enemydir==1)) enemymovetimer=1, enemyx++;	
	if ((enemymovetimer>2) && (enemydir==3)) enemymovetimer=1, enemyy--;
	if ((enemymovetimer>2) && (enemydir==4)) enemymovetimer=1, enemyy++;	
	
	if ((dot1x==400) && (clearmaze==0) && (dot2x==400)) clearmaze=1;
	


	
	if (clearmaze==1) {
		if (level==0) copymem((void*)BGMap(1), (void*)LEVEL1MAPOPEN, 256*16);
		if (level==1) copymem((void*)BGMap(1), (void*)LEVEL2MAPOPEN, 256*16);	
		clearmaze=2;
		}
	
	
	}
	StopAllSounds();
	main_3();
	}
	